import { Model } from "../../../shared";
import { JsonMetadataLoader } from './JsonMetadataLoader';
import { removeEmptyChars } from "../../../utils";
import { MasterEditionLoader } from './MasterEditionLoader';
export class Nft extends Model {
    constructor(metadataAccount) {
        super();
        this.metadataAccount = metadataAccount;
        this.metadataLoader = new JsonMetadataLoader(this);
        this.masterEditionLoader = new MasterEditionLoader(this);
        this.updateAuthority = metadataAccount.data.updateAuthority;
        this.mint = metadataAccount.data.mint;
        this.name = removeEmptyChars(metadataAccount.data.data.name);
        this.symbol = removeEmptyChars(metadataAccount.data.data.symbol);
        this.uri = removeEmptyChars(metadataAccount.data.data.uri);
        this.sellerFeeBasisPoints = metadataAccount.data.data.sellerFeeBasisPoints;
        this.creators = metadataAccount.data.data.creators;
        this.primarySaleHappened = metadataAccount.data.primarySaleHappened;
        this.isMutable = metadataAccount.data.isMutable;
        this.editionNonce = metadataAccount.data.editionNonce;
        this.tokenStandard = metadataAccount.data.tokenStandard;
        this.collection = metadataAccount.data.collection;
        this.uses = metadataAccount.data.uses;
    }
    get metadata() {
        var _a;
        return (_a = this.metadataLoader.getResult()) !== null && _a !== void 0 ? _a : {};
    }
    get masterEditionAccount() {
        var _a;
        return (_a = this.masterEditionLoader.getResult()) !== null && _a !== void 0 ? _a : null;
    }
    get masterEdition() {
        var _a, _b;
        return (_b = (_a = this.masterEditionAccount) === null || _a === void 0 ? void 0 : _a.data) !== null && _b !== void 0 ? _b : {};
    }
    is(other) {
        const mint = other instanceof Nft ? other.mint : other;
        return this.mint.equals(mint);
    }
}
//# sourceMappingURL=Nft.js.map