import { TokenMetadataProgram } from "../../../programs";
import { OperationHandler } from "../../../shared";
import { FindNftsByMintListOperation } from '../operations';
export class FindNftsByCreatorOnChainOperationHandler extends OperationHandler {
    async handle(operation) {
        const { creator, position = 1 } = operation.input;
        const mints = await TokenMetadataProgram.metadataV1Accounts(this.metaplex.connection)
            .selectMint()
            .whereCreator(position, creator)
            .getDataAsPublicKeys();
        const nfts = await this.metaplex.execute(new FindNftsByMintListOperation(mints));
        return nfts.filter((nft) => nft !== null);
    }
}
//# sourceMappingURL=FindNftsByCreatorOnChainOperationHandler.js.map