import { ConfirmOptions, PublicKey } from '@solana/web3.js';
import { Collection, Creator, Uses } from '@metaplex-foundation/mpl-token-metadata';
import { Operation, Signer } from "../../../shared";
import { Nft } from '../models';
export declare class UpdateNftOperation extends Operation<UpdateNftInput, UpdateNftOutput> {
}
export interface UpdateNftInput {
    nft: Nft;
    name?: string;
    symbol?: string;
    uri?: string;
    sellerFeeBasisPoints?: number;
    creators?: Creator[];
    collection?: Collection;
    uses?: Uses;
    newUpdateAuthority?: PublicKey;
    primarySaleHappened?: boolean;
    isMutable?: boolean;
    updateAuthority?: Signer;
    confirmOptions?: ConfirmOptions;
}
export interface UpdateNftOutput {
    transactionId: string;
}
