import { Metaplex } from "../Metaplex";
import { InputOfOperation, Operation, OutputOfOperation } from './Operation';
export declare type OperationHandlerConstructor<T extends Operation<I, O>, I = InputOfOperation<T>, O = OutputOfOperation<T>> = {
    new (metaplex: Metaplex): OperationHandler<T, I, O>;
};
export declare abstract class OperationHandler<T extends Operation<I, O>, I = InputOfOperation<T>, O = OutputOfOperation<T>> {
    metaplex: Metaplex;
    constructor(metaplex: Metaplex);
    abstract handle(operation: T): Promise<O>;
}
